/////////////////////////////////////////////////
//Beispiel aus Kapitel Bibliotheken: toxiclips
//2D Simplex-Noise2 zum zeichnen eines 3D-Musters
/////////////////////////////////////////////////
import toxi.math.noise.*;

void setup() {
  smooth(0);
  size(1000, 1000, P3D);
  background(0);
  noStroke();
  float xstart = random(20);//Zufällige Startwerte damit ...
  float ynoise = random(2);//das Bild immer anders aussieht.
  translate(width / 2, height / 2, 0);//Zentrierung
  for (float y = -(height /10); y <= (height /10); y += 0.5) {
    ynoise += 0.007; //nächster y-Parameter 
    float xnoise = xstart;
    for (float x = -(width / 10); x <= (width / 10); x += 0.5) {
      xnoise += 0.007;//nächster x-Parameter  
      if(x>=(width/10) & y%10==0) {//Farbwechsel bei dieser Bedingung
        fill(random(255),random(255),random(255));
      }
     float noiseFaktor = (float)SimplexNoise.noise(xnoise, ynoise);
      zeichnePunkt(x, y, noiseFaktor);
    }
  }
}
//Die zeichnePunkt-Methode nutzt SimplexNoise für alle drei Koordinaten
void zeichnePunkt(float x, float y, float noiseFaktor) {
  pushMatrix();
    translate(x * noiseFaktor * 4, y * noiseFaktor * 4, noiseFaktor*x*y/100);
    float punktGroesse = abs(noiseFaktor * 4);
    ellipse(0, 0, punktGroesse, punktGroesse);
  popMatrix();
}